;;;-*-Mode: LISP; Package: CCL -*-

;;	Change History (most recent first):
;;  2 6/9/97   akh  the 3 boots
;;  27 10/9/96 akh  load views twice again due to bootstrapping def of change-mouse-view in l1-events
;;  26 10/7/96 akh  no new-traps-appget
;;  21 7/11/95 akh  make-fred-fasl is an *always-module*
;;  20 7/7/95  akh  added make-fred-fasl to aux-modules
;;  5 2/17/95  akh  add mac-file-io
;;  4 2/15/95  slh  added boyer-moore
;;  (do not edit before this line!!)

; Copyright 1986-1988 Coral Software Corp.
; Copyright 1989-1994 Apple Computer, Inc.
; Copyright 1995 Digitool, Inc.

(in-package :ccl)

; Modification History
;
;  9/14/95 slh   added setf-runtime
;  7/12/95 slh   added make-compiler-kit
;  6/29/95 slh   nuke some XX-appgen files, use patches instead
;  6/27/95 slh   hide-listener-support (needed for MCL-AppGen)
;  6/21/95 slh   appgen-misc module
;  6/20/95 slh   new AppGen files
;--------------- 3.0r1
;  6/07/95 slh   new-file-dialogs
;  5/12/95 slh   new-traps
;  4/26/95 slh   old-file-dialogs
;  4/14/95 slh   added boot-init save make-functions-resident
;  4/11/95 slh   build-application module
;  4/06/95 slh   doc-window module
;  4/05/95 slh   backtrace is not optional, backtrace-lds is
;  3/30/95 slh   merge in base-app changes
;                added backtrace-lds module
;--------------  3.0d18
; 2/15/95 slh  added boyer-moore to lib
;------------- 3.0d17
;12/26/94 alice lets not load scrolling-fred-view twice
;08/18/93 bill add script-manager
;07/14/93 bill skip-copy restart in merge-ccl-update
;------------- 3.0d12
;07/13/93 alice scrolling-fred-dialog-item => scrolling-fred-view
;06/02/93 bill time-delta arg to merge-ccl-update
;------------- 2.1d6
;05/04/93 bill start-file keyword to merge-ccl-update
;04/14/93 bill fred-menu is no more. catch-cancel around eval in merge-ccl-update.
;04/13/93 bill yes-mode in merge-ccl-update. require-update-modules & xcompile-ccl
;              reverted.
;04/07/93 bill merge-ccl-update now just updates the write date instead of copying
;              when two files compare as identical and copy-identical-files is true.
;------------- 2.1d5
;03/??/93 alice move add some modules for new-fred-window
;02/23/93 bill "~&" added to one of the format strings in merge-ccl-update.
;12/10/92 bill merge-ccl-update: abort restart around the eval, copy-identical-files keyword arg
;12/05/92 bill speed up same-file-write-date-and-length-p
;08/10/92 bill add resident-interfaces to *other-lib-modules*
;07/09/92 bill add patchenv to *aux-modules*
;------------- 2.0
; 01/07/92 gb  don't require RECORDS.
;------------- 2.0b4
;11/13/91 bill delete-ccl-system-source-fasls handles a null fasl file.
;              Add INTERFACES to *aux-modules*
;11/07/91 bill remove INTERFACES: users will have to load this themselves
;08/26/91 bill move INTERFACES to *code-modules*
;08/21/91 bill add INTERFACES
;07/05/91 bill add records & help-manager to *aux-modules*
;05/29/91 bill delete-ccl-system-source-fasls
;------------- 2.0b2
;05/16/91 bill process *eval-queue* while waiting for compare to be over in merge-ccl-update
;05/07/91 bill little pathname change in merge-ccl-update.
;04/05/91 bill merge-ccl-update needed a translate-logical-pathname, also
;              back-translate-pathname for printing.
;02/27/91 bill add method-combination
;02/15/91 bill add l1-dcode
;02/07/91 alice l1-pathnames, ccl; => ccl:
;---- 2.0b1
;02/04/91 bill mac-namestring -> namestring to preserve escapes.
;01/22/91 bill add merge-ccl-update
;01/18/91 bill no more distrib-lap
;01/11/91 bill add distrib-lap, lisp-package
;01/09/91 bill add ff & distrib-inits to *aux-modules*
;12/26/90 joe  added deftrap and simple-db to *env-modules* in preparation for converting
;              lisp to the new trap interface.
;12/8/90  joe  add l1-highlevel-events
;11/21/90 gb   zap aplink*, meter.
;09/17/90 bill added inspector, inspector-objects, deftrap, simple-db
;              Removed inspect
;09/07/90 bill Moved defstruct into *env-modules*: mactypes uses it.
;              eliminated *load-modules*
;08/23/90 joe added *load-modules* - independent module load variable
;08/08/90 gb  *aux-modules*.
;07/??/90 (joe) setf before records.
;05/27/90 gb  Added encapsulate.
;04/30/90 gb  nx8 -> nx.
;2/14/90 gz   Added aplink-macros, aplink, aplink-dump.
;01/03/89 gz  Added edhardcopy to bccl-modules.
;12/29/89 gz  added disasm.  Added trap-support to bccl-modules.
;01/05/89 bill Added windoids.
;12/29/89 bill Added views.
;12/27/89 gz  rename disasm -> disassemble.  EdHardcopy rides again.
;12/6/89 bill Add l1-sort.  Remove clos (moved into l1-clos).
;11/20/89 gz   Reorder *env-modules* slightly (fredenv needs lap).
;13-Nov-89 Mly Bind *package*
;10/4/89  gz   no more l1-macros.
;09/27/89 gb   comment-out eval & step for time being.
;09/15/89 bill Remove clos-l1-streams & clos-l1-windows.  Time to boot in CLOS
;09/14/89 bill clos-l1-windows back to *level-1-modules* where it belongs
;              Add clos-l1-streams ti *level-1-modules*
;09/09/89 bill Moved setf to *env-modules*. dialogs needs it for its setf methods.
;09/08/89 bill Add clos-l1-windows to *env-modules*.  This is temporary.
;              l1-windows will be replaced by clos-l1-windows as soon as I convert
;              Fred to CLOS.  There are some bootstrapping problems here, I think.
;08/24/89 gb Just say no to hardcopy, yes to chars.
;            add nx2a.
;18-apr-89 as color
;03/23/89 gz split off l1-utils, l1-boot, l1-init, l1-numbers.
;03/10/89 gz l1-clos.
; 03/02/89 gb  l1-sysio, l1-symhash.
;12/30/88 gz l1-edbuf.  No more bufstream.  added xcompile-ccl.
;11/26/88 gz New display code, no more fred-execute.
;11/25/88 gz no more record-source.
;11/16/88 gz No more edwin-utils
;9/11/88 gz added meter to other-lib-modules.
;8/17/88 gz added l1-files. hash, defstruct -> lib.
;8/11/88 gz new scheme.
;8/2/88  gb require lap, lapmacros.
;7/30/88 gz Lisp-8
;5/3/88 jaj new for ccl

;This file will load into a bare level-1 (no level-2 or nuthin').

(eval-when (eval compile load)
  (proclaim '(special *level-1-modules* *compiler-modules* *env-modules*
              *other-lib-modules* *lib-modules* *code-modules* *load-modules*
              *ccl-system* *bccl-modules* *aux-modules* *always-modules*
              *lds-modules* *always-modules*)))

(require 'systems)

(setq *level-1-modules*
      '(level-1
        ;level-1-test                    ; for debugging
        ;level-1-appgen                  ; for AppGen
        l1-boot-1 l1-boot-2 l1-boot-3
        ;l1-boot ;l1-boot-appgen
        l1-utils l1-init l1-symhash l1-numbers l1-aprims
        68k-misc
        l1-sort l1-dcode l1-clos
        l1-streams l1-files l1-io l1-menus
        l1-windows l1-edbuf l1-edcmd
        l0-cfm-support
        script-manager l1-edfrec l1-edwin 
        scroll-bar-dialog-items scrolling-fred-view new-fred-window
        l1-events l1-highlevel-events l1-format l1-readloop
        l1-initmenus l1-sysio l1-pathnames
        l1-listener
        l1-boot-lds l1-base-app l1-initmenus-lds l1-ed-lds l1-readloop-lds
        l1-stack-groups l1-processes sysutils
        views dialogs
        #+interfaces-2 l1-traps))

(setq *compiler-modules*
      '(nx optimizers))

(setq *env-modules*
      '(hash
        backquote
        lispequ
        sysequ
        toolequ
        level-2
        trap-support
        nxenv ; ?
        lap
        lapmacros
        fredenv
        defstruct-macros 
        lists chars
        setf setf-runtime
        defstruct defstruct-lds
        mactypes
        simple-db
        deftrap
        defrecord
        #|records|#
        ;dialogs
        color
        nfcomp
        #|aplink-macros|#
        subprims8
        views
        windoids))

(setq *other-lib-modules*
      '(fred-misc streams pathnames
        backtrace
        edhardcopy
        sanetraps
        apropos
        numbers dumplisp
        disasm
        disassemble
        resident-interfaces mac-file-io boyer-moore
        #|meter aplink-dump aplink|#))

(setq *bccl-modules*
      '(backquote level-2 lists dialogs hash nfcomp
        fred-misc streams pathnames backtrace chars
        disasm edhardcopy defstruct apropos
        numbers dumplisp setf color views windoids
        trap-support aplink-dump aplink encapsulate
        ))

(setq *lib-modules*
      (append *env-modules* *other-lib-modules*))

(setq *code-modules*
      '(encapsulate
        #+interfaces-2 new-traps        ; after encapsulate
         read
        misc doc-window
        arrays-fry sequences sort method-combination
        case-error
        pprint
        format time
        print-db
        eval
        fred-additions arglist
        fred-help edit-definition list-definitions
        pop-up-menu
        #|scroll-bar-dialog-items|#
        ccl-menus ccl-menus-lds
        mcl-extensions
        inspector
        inspector-objects
        apropos-dialog
        step
        step-window
        #|scrolling-fred-view|#
        edit-callers 
        search-files
        backtrace-lds
        ccl-export-syms
        font-menus  ; after above which does system-fixups enabling defgeneric
        color-dialog-items-os8-5
        ))

; Not part of system, but need to be compiled to load it and/or save image/application.
(setq *aux-modules* '(systems compile-ccl ff distrib-inits lisp-package
                      resources help-manager interfaces patchenv
                      save-application-dialog build-application
                      ;boot-init save make-functions-resident
                      ; resident-functions
                      old-file-dialogs new-file-dialogs
                      appgen-misc ;; #+interfaces-2 new-traps-appgen
                      ;dumplisp-appgen pathnames-appgen
                      ;appgen-patches
                      icon-dialog-item
                      hide-listener-support
                      loop
                      ;make-fred-fasl
                      ))

(setq *always-modules* '(;make-fred-fasl
                         ;make-compiler-kit
                         ))

; tools
;  debugging (backtrace-lds)
;  environment (apropos, boyer-moore, etc.)
; compile-time (backquote, subprims, etc.)
; low-level (sanetraps, etc.)
; optional (pprint, eval, windoids)


(defun find-module (module &aux data fasl sources)
  (if (setq data (assoc module *ccl-system*))
    (progn
      (setq fasl (cadr data) sources (caddr data))
      (values fasl (if (listp sources) sources (list sources))))
    (error "Module ~S not defined" module)))

(defun require-module (module force-load)
  (multiple-value-bind (fasl source) (find-module module)
      (setq source (car source))
      (if (if fasl (probe-file fasl))
        (if force-load
          (progn
            (load fasl)
            (provide module))
          (require module fasl))
        (if (probe-file source)
          (progn
            (if fasl (format t "~&Can't find ~S so requiring ~S instead"
                             fasl source))
            (if force-load
              (progn
                (load source)
                (provide module))
              (require module source)))
          (error "Can't find ~S or ~S" fasl source)))))

(defun require-modules (modules &optional force-load)
  (if (not (listp modules)) (setq modules (list modules)))
  (let ((*package* (find-package :ccl)))
    (dolist (m (if (listp modules) modules (list modules)) t)
      (require-module m force-load))))

(defun needs-compile-p (fasl sources force-compile)
  (if fasl
    (if (eq force-compile t) t
        (if (not (probe-file fasl)) t
            (let ((fasldate (file-write-date fasl)))
              (if (if (integerp force-compile) (> force-compile fasldate)) t
                  (tagbody loop
                    (if (null sources)
                      (return-from needs-compile-p nil))
                    (if (> (file-write-date (car sources)) fasldate)
                      (return-from needs-compile-p t))
                    (setq sources (cdr sources))
                    (go loop))))))))

;compile if needed.
(defun compile-modules (modules &optional force-compile)
  (if (not (listp modules)) (setq modules (list modules)))
  (let ((*package* (find-package :ccl)))
   (tagbody loop
    (if (null modules) (return-from compile-modules t))
    (multiple-value-bind (fasl sources) (find-module (car modules))
      (if (needs-compile-p fasl sources force-compile)
        (progn
          (require'nfcomp)
          (compile-file (car sources) :output-file fasl :verbose t))))
    (setq modules (cdr modules))
    (go loop))))

;compile if needed, load if recompiled.
(defun update-modules (modules &optional force-compile)
  (if (not (listp modules)) (setq modules (list modules)))
  (let ((*package* (find-package :ccl)))
   (tagbody loop
    (if (null modules) (return-from update-modules t))
    (multiple-value-bind (fasl sources) (find-module (car modules))
      (if (needs-compile-p fasl sources force-compile)
        (progn
          (require'nfcomp)
          (let* ((*warn-if-redefine* nil))
            (compile-file (car sources) :output-file fasl :verbose t :load t))
          (provide (car modules)))))
    (setq modules (cdr modules))
    (go loop))))

;load, then update!
(defun require-update-modules (modules &optional force-compile)
  (if (not (listp modules)) (setq modules (list modules)))
  (let ((*package* (find-package :ccl)))
   (tagbody loop
    (if (null modules) (return-from require-update-modules t))
    (require-modules (car modules))
    (update-modules (car modules) force-compile)
    (setq modules (cdr modules))
    (go loop))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun require-env (&optional force-load)
  (require-modules *env-modules* force-load))

(defun compile-level-1 (&optional force-compile)
  (require-env)
  (compile-modules *level-1-modules* force-compile))

(defun compile-compiler (&optional force-compile)
  (compile-modules *compiler-modules* force-compile)
  (compile-modules 'nx-base-app force-compile))

(defun compile-lib (&optional force-compile)
  (compile-modules *lib-modules* force-compile))

(defun compile-code (&optional force-compile)
  (compile-modules *code-modules* force-compile))

(defun load-ccl ()
  (require-modules *compiler-modules*)
  (require-modules *lib-modules*)
  (require-modules *code-modules*))

(defun compile-ccl (&optional force-compile)
  (update-modules *compiler-modules* force-compile)
  (require-modules *env-modules*)
  (update-modules *env-modules* force-compile)
  (compile-modules *level-1-modules* force-compile)
  (update-modules *other-lib-modules* force-compile)
  (require-modules *other-lib-modules*)
  (require-update-modules *code-modules* force-compile)
  (compile-modules *aux-modules* force-compile)
  (compile-modules *always-modules* t))

;Compile but don't load
(defun xcompile-ccl (&optional force)
  (compile-compiler force)
  (compile-modules *level-1-modules* force)
  (compile-modules *lib-modules* force)
  (compile-modules *code-modules* force)
  (compile-modules *aux-modules* force)
  (compile-modules *always-modules* t))

(defun load-bccl ()
  (setq *record-source-file* nil)
  (require-modules *compiler-modules*)
  (require-modules *bccl-modules*)
  (require-modules *code-modules*))

#|
	Change History (most recent last):
	2	12/29/94	akh	merge with d13
	3	1/2/95	akh	dont do scroll-bar-dialog-items twice
|# ;(do not edit past this line!!)
