;; 02/26/04 lose mactcp and ccl:library;interfaces.lisp, ff-call-68k
;; 01/24/04 loze ff.lisp/pfsl, anarchie-interface. loze all ccl:sourceserver;fasls; and help-map
;; add shannons font-sampler
;; include driver.lisp even though it does not work on OSX
;; include compiler;nxenv for clim
;; lose examples;ballon-help-menu
;; aug 01 akh include lib;%source-files%
;; 01/24/01 akh - get interfaces;index too
;; 07/07/01 akh lose logical-dir-compatibility, probably should lose library;traps too - did that already
;;   and library;records.lisp

(in-package :ccl)

(defun dir-plus-wild (directory)
  (append directory '(:wild-inferiors)))

;; presumably old-source-dir has (the names of) all the source files we want. current-source-dir is where they are now
;; and new-source-dir is where they are going
;; so what happened to sourceserver 
;; don't forget color-dialog-items-..
;; this just gets :text files    
(defun get-the-files (current-source-dir old-source-dir new-source-dir)
  (let* (;(current-source-full-dir (full-pathname current-source-dir))
         (old-source-files (directory 
                            (make-pathname :directory (dir-plus-wild (pathname-directory (full-pathname old-source-dir)))
                                           :name "*" :type "*")
                            :test #'(lambda (f)(eq (mac-file-type f) :text))))
         (dir-len (length (pathname-directory (FULL-PATHNAME current-source-dir))))
         (old-dir-len (length (pathname-directory (FULL-PATHNAME old-source-dir)))))
    (dolist (f old-source-files)
      (let* ((new-dir (make-pathname :directory (append (pathname-directory (full-pathname new-source-dir))
                                                        (nthcdr dir-len (pathname-directory f)))))
             (new-dest (merge-pathnames new-dir f))
             (in-dir (make-pathname :directory (append (pathname-directory (full-pathname current-source-dir))
                                                        (nthcdr old-dir-len (pathname-directory f)))))
             (the-source (merge-pathnames in-dir f)))

        (cerror "our" "pukw ~a ~s ~s ~S" the-source new-dest in-dir f)
        
        (copy-file the-source new-dest :if-exists :supersede)))))

;(create-directory "ccl:")

;(get-the-files "ccl:" "bigzoe-real:mcl-4.3-3.4-b1:mcl-4.3-3.4-b1:" "ccl:")

(defparameter *interface-files* (directory "ccl:library;interfaces;**;*"))
(defparameter *appearance-files* (directory "ccl:examples;appearance-manager-folder;**;*"))


(defun get-the-files2 (dest-source-host files)
  (setq dest-source-host (pathname dest-source-host))
  (let* ()
    #+carbon-compat    
    (setq files (mapcar #'(lambda (f) 
                            (if (string-equal (pathname-type f) "pfsl")
                              (let ((new-f (merge-pathnames *.pfsl-pathname* f)))
                                new-f)
                              f))
                        files))
    (dolist (f files)
      (when (not (logical-pathname-p f))
        (setq f (back-translate-pathname-11 f (list "ccl")))  ;; dont back up to ccl:interfaces;
        ;(cerror "a" "b")
        )
      
      (let* ((new-dest (merge-pathnames dest-source-host (pathname f))))
        ;(cerror "our" "pukw ~a ~s " f  new-dest)
        (if  (and (not (probe-file f))(string-equal  (pathname-type f)(pathname-type *.pfsl-pathname*)))
          (compile-file (merge-pathnames *.lisp-pathname* f) :verbose t :output-file f))
        (copy-file f new-dest :if-exists :supersede)))))

(defun back-translate-pathname-11 (path &optional hosts)
  (dolist (host %logical-host-translations%)
    (when (or (null hosts) (member (car host) hosts :test 'string-equal))
      (dolist (trans (cdr host))
        (when (pathname-match-p path (cadr trans))
          (let* (newpath)          
            (setq newpath (translate-pathname path (cadr trans) (car trans) :reversible t))
            (return-from back-translate-pathname-11 newpath)))))))

(setq *files-to-ship*

(append (list #P"ccl:compiler;lambda-list.lisp"
 #P"ccl:compiler;nx-base-app.lisp"
 #P"ccl:compiler;nxenv.lisp" ; for CLIM probably not needed now but wtf include it
 
 #P"ccl:compiler;nx-basic.lisp"
 #P"ccl:compiler;optimizers.lisp"
 #P"ccl:compiler;PPC;number-case-macro.lisp"
 #P"ccl:compiler;PPC;number-macros.lisp"
 #P"ccl:compiler;PPC;ppc-arch.lisp"
 #P"ccl:compiler;PPC;ppc-asm.lisp"
 #P"ccl:compiler;PPC;ppc-disassemble.lisp"
 #P"ccl:compiler;PPC;ppc-lap.lisp"
 #P"ccl:compiler;PPC;ppc-lapmacros.lisp"
 #P"ccl:compiler;PPC;ppc-subprims.lisp"
 ;#P"ccl:Compiler-68K:optimizers.lisp"
 #P"ccl:examples;animated-cursor.lisp"
 ;#P"ccl:examples;animated-cursor.pfsl"
 #P"ccl:examples;appleevent-toolkit.lisp"
 ;#P"ccl:examples;appleevent-toolkit.pfsl"
 #P"ccl:examples;applescript-tools.lisp"
 #P"ccl:examples;array-dialog-item.lisp"
 ;#P"ccl:examples;array-dialog-item.pfsl"
 #P"ccl:examples;assorted-fred-commands.lisp"
 ;#P"ccl:examples;assorted-fred-commands.pfsl"
 #P"ccl:examples;auto-fill.lisp"
 ;#P"ccl:examples;auto-fill.pfsl"
 ;#P"ccl:examples;balloon-help-menu.lisp"
 ;#P"ccl:examples;balloon-help-menu.pfsl"
 #P"ccl:examples;Binhex;binhex resources.rsrc"
 #P"ccl:examples;Binhex;binhex.lisp"
 #P"ccl:examples;cfm-mover.lisp"
 ;#P"ccl:examples;cfm-mover.pfsl"
 ;#P"ccl:examples;changed-files.lisp"
 #P"ccl:examples;check-and-change.lisp"
 ;#P"ccl:examples;check-and-change.pfsl"
 ;#P"ccl:examples;config.lisp"
 #P"ccl:examples;console-log.lisp"
 #P"ccl:examples;contextual-menu-mixin.lisp"
 
 #P"ccl:examples;contextual-menu-cursor.rsrc"
 ;#P"ccl:examples;config.pfsl"
 #P"ccl:examples;define-interrupt-handler.lisp"
 ;#P"ccl:examples;define-interrupt-handler.pfsl"
 ;#P"ccl:examples;defobfun-to-defmethod.lisp"
 ;#P"ccl:examples;defobfun-to-defmethod.pfsl"
 #P"ccl:examples;defsystem.lisp"
 #P"ccl:examples;drag-and-drop.lisp"
 #P"ccl:examples;drag-and-drop-examples;Docs for drag-and-drop.lisp"
 #P"ccl:examples;drag-and-drop-examples;drag-aware-list.lisp" 
 #P"ccl:examples;drag-and-drop-examples;dynamic-views.lisp" 
 #P"ccl:examples;drag-and-drop-examples;fred-drag.lisp" 
 #P"ccl:examples;drag-and-drop-examples;netscape-info.lisp"
 ;#-carbon-compat
 #P"ccl:examples;driver.lisp"
 ;#P"ccl:examples;driver.pfsl"
 #P"ccl:examples;escape-key.lisp"
 ;#P"ccl:examples;escape-key.pfsl"
 #P"ccl:examples;eval-server.lisp"
 ;#P"ccl:examples;eval-server.pfsl"
 #P"ccl:examples;fasl-concatenate.lisp"
 ;#P"ccl:examples;fasl-concatenate.pfsl"
 ; #P"ccl:examples;fast-slot-value.lisp" ; obsolete
 ;#P"ccl:examples;fast-slot-value.pfsl"
 #P"ccl:examples;FF examples;ff-example.c"
 #P"ccl:examples;FF examples;ff-example.c.o"
 #P"ccl:examples;FF examples;ff-example.lisp"
 #P"ccl:examples;FF examples;ff-example.test"
 ;#P"ccl:examples;font-menus.lisp"
 ;#P"ccl:examples;font-menus.pfsl"
 #P"ccl:examples;font-sampler.lisp"
 #P"ccl:examples;font-search.lisp"
 #P"ccl:examples;fred-word-completion.lisp"
 ;#P"ccl:examples;fred-word-completion.pfsl"
 #P"ccl:examples;grapher.lisp"
 ;#P"ccl:examples;grapher.pfsl"
 #P"ccl:examples;library-info.lisp"
 ;#P"ccl:examples;library-info.pfsl"
 #P"ccl:examples;load-all-patches.lisp"
 ;#P"ccl:examples;load-all-patches.pfsl"
 #P"ccl:examples;mark-menu.lisp"
 ;#P"ccl:examples;mark-menu.pfsl"
 #P"ccl:examples;mouse-copy.lisp"
 ;#P"ccl:examples;mouse-copy.pfsl"
 #|
 #P"ccl:examples;NotInROM:*NotInROM-docs.txt"
 #P"ccl:examples;NotInROM:+Devices.lisp"
 #P"ccl:examples;NotInROM:+Devices.pfsl"
 #P"ccl:examples;NotInROM:+Files.lisp"
 #P"ccl:examples;NotInROM:+Files.pfsl"
 #P"ccl:examples;NotInROM:+Menus.lisp"
 #P"ccl:examples;NotInROM:+Menus.pfsl"
 #P"ccl:examples;NotInROM:+OSUtils.lisp"
 #P"ccl:examples;NotInROM:+Packages.lisp"
 #P"ccl:examples;NotInROM:+Power.lisp"
 #P"ccl:examples;NotInROM:+SegLoader.lisp"
 #P"ccl:examples;NotInROM:+Serial.lisp"
 #P"ccl:examples;NotInROM:+Sound.lisp"
 #P"ccl:examples;NotInROM:+TextEdit.lisp"
 #P"ccl:examples;NotInROM:+ToolUtils.lisp"
 #P"ccl:examples;NotInROM:meta-point-patch.lisp"
 #P"ccl:examples;NotInROM:NotInROM-u.lisp"
 #P"ccl:examples;NotInROM:NotInROM-u.pfsl"
 #P"ccl:examples;NotInROM:NotInROM.lisp"
|#
 ;#P"ccl:examples;old-dialog-hooks.lisp"
 ;#P"ccl:examples;old-dialog-hooks.pfsl"
 #P"ccl:examples;old-file-search.lisp"
 ;#P"ccl:examples;old-file-search.pfsl"
 #P"ccl:examples;pict-scrap.lisp"
 ;#P"ccl:examples;pict-scrap.pfsl"
 #P"ccl:examples;picture-files.lisp"
 ;#P"ccl:examples;picture-files.pfsl"
 #P"ccl:examples;appearance-globals.lisp"
 #P"ccl:examples;platinum-pop-up-menus.lisp"
 #P"ccl:examples;print-class-tree.lisp"
 ;#P"ccl:examples;print-class-tree.pfsl"
 #P"ccl:examples;processes.lisp"
 ;#P"ccl:examples;processes.pfsl"
 #P"ccl:examples;progress-indicator.lisp"
 ;#P"ccl:examples;progress-indicator.pfsl"
 #P"ccl:examples;query-replace.lisp"
 ;#P"ccl:examples;query-replace.pfsl"
 #P"ccl:examples;scrolling-windows.lisp"
 ;#P"ccl:examples;scrolling-windows.pfsl"
 #P"ccl:examples;serial-streams.lisp"
 ;#P"ccl:examples;serial-streams.pfsl"
 #1P"ccl:examples;series;README-MCL-series"
 #P"ccl:examples;series;s.lisp"
 #P"ccl:examples;series;sdoc.txt"
 #P"ccl:examples;series;stest.lisp"
 #P"ccl:examples;shapes-code.lisp"
 ;#P"ccl:examples;shapes-code.pfsl"
 #P"ccl:examples;text-edit-dialog-item.lisp"
 #P"ccl:examples;thermometer.lisp"
 #P"ccl:examples;timers.lisp"
 ;#P"ccl:examples;timers.pfsl"
 #P"ccl:examples;toolserver.lisp"
 #P"ccl:examples;turtles.lisp"
 #P"ccl:examples;uk-keyboard.lisp"
 #P"ccl:examples;view-example.lisp"
 #P"ccl:examples;webster.lisp"
 #P"ccl:examples;windoid-key-events.lisp"
 #1P"ccl:Interface tools;About Interface Tools"
 ;#P"ccl:Interface tools;dialog-editor.fasl"
 #P"ccl:Interface tools;Dialog-Editor.lisp"
 #P"ccl:Interface tools;dialog-editor.pfsl"
 ;#P"ccl:Interface tools;ift-init.fasl"
 #P"ccl:Interface tools;ift-init.Lisp"
 #P"ccl:Interface tools;ift-init.pfsl"
 ;#P"ccl:Interface tools;ift-macros.fasl"
 #P"ccl:Interface tools;ift-macros.Lisp"
 #P"ccl:Interface tools;ift-macros.pfsl"
 ;#P"ccl:Interface tools;ift-menus.fasl"
 #P"ccl:Interface tools;ift-menus.Lisp"
 #P"ccl:Interface tools;ift-menus.pfsl"
 ;#P"ccl:Interface tools;ift-utils.fasl"
 #P"ccl:Interface tools;ift-utils.lisp"
 #P"ccl:Interface tools;ift-utils.pfsl"
 #P"ccl:Interface tools;interface-tools.lisp"
 ;#P"ccl:Interface tools;item-defs.fasl"
 #P"ccl:Interface tools;item-defs.Lisp"
 #P"ccl:Interface tools;item-defs.pfsl"
 #P"ccl:Interface tools;make-ift.lisp"
 ;#P"ccl:Interface tools;menu-editor.fasl"
 #P"ccl:Interface tools;menu-editor.Lisp"
 #P"ccl:Interface tools;menu-editor.pfsl"
 #P"ccl:Level-0;l0-cfm-support.lisp"
 ;;#P"ccl:level-1;68K:68k-misc.lisp"
 ;#P"ccl:level-1;68K:l1-aprims-68K.lisp"
 ;#P"ccl:level-1;68K:l1-format.lisp"
 ;#P"ccl:level-1;68K:l1-io.lisp"
 ;#P"ccl:level-1;68K:l1-numbers.lisp"
 ;#P"ccl:level-1;68K:l1-readloop.lisp"
 ;#P"ccl:level-1;68K:l1-sort.lisp"
 ;#P"ccl:level-1;68K:L1-stack-groups.lisp"
 ;#P"ccl:level-1;68K:l1-symhash.lisp"
 ;#P"ccl:level-1;68K:l1-utils-68K.lisp"
 ;#P"ccl:level-1;68K:level-1-com.lisp"
 ;#P"ccl:level-1;68K:level-1-defs.lisp"
 ;#P"ccl:level-1;68K:level-1.lisp"
 ;#P"ccl:level-1;68K:sysutils.lisp"
 #P"ccl:level-1;l1-aprims.lisp"
 ;#P"ccl:level-1;l1-base-app.lisp"
 #P"ccl:level-1;l1-boot-1.lisp"
 #P"ccl:level-1;l1-boot-2.lisp"
 #P"ccl:level-1;l1-boot-3.lisp"
 #P"ccl:level-1;l1-boot-lds.lisp"
 #P"ccl:level-1;l1-cl-package.lisp"
 #P"ccl:level-1;l1-ed-lds.lisp"
 #P"ccl:level-1;l1-edbuf.lisp"
 #P"ccl:level-1;l1-edcmd.lisp"
 #P"ccl:level-1;l1-edfrec.lisp"
 #P"ccl:level-1;l1-edwin.lisp"
 #P"ccl:level-1;l1-events.lisp"
 #P"ccl:level-1;l1-files.lisp"
 #P"ccl:level-1;l1-highlevel-events.lisp"
 #P"ccl:level-1;l1-init.lisp"
 #P"ccl:level-1;l1-initmenus-lds.lisp"
 #P"ccl:level-1;l1-initmenus.lisp"
 #P"ccl:level-1;l1-listener.lisp"
 #P"ccl:level-1;l1-menus.lisp"
 #P"ccl:level-1;l1-pathnames.lisp"
 #P"ccl:level-1;l1-processes.lisp"
 #P"ccl:level-1;l1-readloop-lds.lisp"
 #P"ccl:level-1;l1-streams.lisp"
 #P"ccl:level-1;l1-sysio.lisp"
 #P"ccl:level-1;l1-traps.lisp"
 #P"ccl:level-1;l1-utils.lisp"
 #P"ccl:level-1;l1-windows.lisp"
 ;#P"ccl:level-1;level-1-test.lisp"
 #P"ccl:level-1;new-fred-window.lisp"
 #P"ccl:level-1;ppc;l1-error-signal.lisp"
 #P"ccl:level-1;ppc;l1-error-system.lisp"
 #P"ccl:level-1;ppc;l1-format.lisp"
 #P"ccl:level-1;ppc;l1-io.lisp"
 #P"ccl:level-1;ppc;l1-numbers.lisp"
 #P"ccl:level-1;ppc;l1-reader.lisp"
 #P"ccl:level-1;ppc;l1-readloop.lisp"
 #P"ccl:level-1;ppc;l1-sort.lisp"
 #P"ccl:level-1;ppc;l1-stack-groups.lisp"
 #P"ccl:level-1;ppc;l1-symhash.lisp"
 #P"ccl:level-1;ppc;l1-typesys.lisp"
 #P"ccl:level-1;ppc;l1-utils-ppc.lisp"
 #P"ccl:level-1;ppc;level-1.lisp"
 #P"ccl:level-1;ppc;ppc-callback-support.lisp"
 #P"ccl:level-1;ppc;ppc-stack-groups.lisp"
 ;#P"ccl:level-1;ppc;ppc-stack-groups.pfsl"
 #P"ccl:level-1;ppc;ppc-test-arith.lisp"
 #P"ccl:level-1;ppc;ppc-trap-support.lisp"
 #P"ccl:level-1;ppc;sysutils.lisp"
 #P"ccl:level-1;script-manager.lisp"
 #P"ccl:level-1;sysutils.lisp"
 #P"ccl:level-1;version.lisp"
 ;#P"ccl:lib;68K:backtrace-lds.lisp"
 ;#P"ccl:lib;68K:backtrace.lisp"
 ;#P"ccl:lib;68K:hash-68K.lisp"
 ;#P"ccl:lib;68K:meter.lisp"
 ;#P"ccl:lib;68K:nfcomp.lisp"
 ;#P"ccl:lib;68K:numbers.lisp"
 ;#P"ccl:lib;68K:sort.lisp"
 #P"ccl:lib;%source-files%.lisp" 
 #P"ccl:lib;apropos-dialog.lisp"
 #P"ccl:lib;apropos.lisp" #P"ccl:lib;arglist.lisp"
 #P"ccl:lib;arrays-fry.lisp"
 #P"ccl:lib;backquote.lisp"
 #P"ccl:lib;boyer-moore.lisp"
 #P"ccl:lib;case-error.lisp"
 #P"ccl:lib;ccl-export-syms.lisp"
 #P"ccl:lib;ccl-menus-lds.lisp"
 #P"ccl:lib;ccl-menus.lisp" #P"ccl:lib;chars.lisp"
 #P"ccl:lib;color.lisp" #P"ccl:lib;defrecord.lisp"
 #P"ccl:lib;defstruct-lds.lisp"
 #P"ccl:lib;defstruct-macros.lisp"
 #P"ccl:lib;defstruct.lisp"
 #P"ccl:lib;deftrap.lisp" #P"ccl:lib;dialogs.lisp"
 #P"ccl:lib;disasm.lisp"
 #P"ccl:lib;disassemble.lisp"
 #P"ccl:lib;distrib-inits.lisp"
 ;#P"ccl:lib;distrib-lap.lisp"  ; ??
 #P"ccl:lib;doc-window.lisp"  
 #P"ccl:lib;dumplisp.lisp"
 #P"ccl:lib;EdHardcopy.lisp"
 ;#P"ccl:lib;EdHardcopy-osx.lisp"
 #P"ccl:lib;edit-callers.lisp"
 #P"ccl:lib;edit-definition.lisp"
 #P"ccl:lib;encapsulate.lisp"
 #P"ccl:lib;eval.lisp"
 ;#P"ccl:lib;ff-call-68k.lisp"
 #P"ccl:lib;ff-source.lisp"
 #P"ccl:lib;format.lisp"
 #P"ccl:lib;fred-additions.lisp"
 #P"ccl:lib;fred-help.lisp"
 #P"ccl:lib;fred-misc.lisp"
 #P"ccl:lib;fredenv.lisp" #P"ccl:lib;hash.lisp"
 #P"ccl:lib;init-ccl.lisp"
 #P"ccl:lib;inspector-objects.lisp"
 #P"ccl:lib;inspector.lisp" #P"ccl:lib;lap.lisp"
 #P"ccl:lib;LapMacros.lisp"
 #P"ccl:lib;level-2.lisp"
 #P"ccl:lib;list-definitions.lisp"
 #P"ccl:lib;lists.lisp" #P"ccl:lib;mactypes.lisp"
 #P"ccl:lib;mcl-extensions.lisp"
 #P"ccl:lib;method-combination.lisp"
 #P"ccl:lib;misc.lisp" #P"ccl:lib;new-traps.lisp"
 ;#P"ccl:lib;patchenv.lisp"
 #P"ccl:lib;pathnames.lisp"
 #P"ccl:lib;ppc;backtrace-lds.lisp"
 #P"ccl:lib;ppc;backtrace.lisp"
 #P"ccl:lib;ppc;meter-consing.lisp"
 #P"ccl:lib;ppc;nfcomp.lisp"
 #P"ccl:lib;ppc;numbers.lisp"
 #P"ccl:lib;ppc;ppc-metering.lisp"
 #P"ccl:lib;ppc;sort.lisp" #P"ccl:lib;pprint.lisp"
 #P"ccl:lib;print-db.lisp" #P"ccl:lib;read.lisp"
 #P"ccl:lib;resident-interfaces.lisp"
 ;#P"ccl:lib;resident-interfaces.pfsl"
 ;#P"ccl:lib;SANEtraps.lisp"
 #P"ccl:lib;search-files.lisp"
 #P"ccl:lib;sequences.lisp"
 #P"ccl:lib;setf-runtime.lisp"
 #P"ccl:lib;setf.lisp" #P"ccl:lib;simple-db.lisp"
 #P"ccl:lib;step-window.lisp"
 #P"ccl:lib;Step.lisp" #P"ccl:lib;streams.lisp"
 #P"ccl:lib;sysequ.lisp" #P"ccl:lib;time.lisp"
 #P"ccl:lib;ToolEqu.lisp"
 #P"ccl:lib;trap-support.lisp"
 #P"ccl:lib;views.lisp" #P"ccl:lib;windoids.lisp"
 #1P"ccl:library;-README-"
 #P"ccl:library;ansi-make-load-form.lisp"
 ;#P"ccl:library;color-dialog-items-os8-5.fasl"
 #P"ccl:library;color-dialog-items-OS8-5.lisp"
 #P"ccl:library;color-dialog-items-OS8-5.pfsl"
 #P"ccl:library;cursors.rsrc"
 ;#P"ccl:library;dialog-macros.fasl"
 #P"ccl:library;dialog-macros.lisp"
 #P"ccl:library;dialog-macros.pfsl"
 ;#P"ccl:library;extended-loop.fasl"
 #P"ccl:library;extended-loop.lisp"
 ;#P"ccl:library;ff.fasl" 
 ;#P"ccl:library;ff.pfsl"  ;; ??
 ;#P"ccl:library;font-menus.fasl"
 #P"ccl:library;font-menus.lisp"
 #P"ccl:library;font-menus.pfsl"
 #P"ccl:library;font-color-palette.lisp"
 ;#P"ccl:library;fred-compatibility.fasl"
 #P"ccl:library;fred-compatibility.lisp"
 #P"ccl:library;fred-compatibility.pfsl"
; #P"ccl:library;graphic-items.fasl"
 #P"ccl:library;graphic-items.lisp"
 #P"ccl:library;graphic-items.pfsl"
 ;#P"ccl:library;help-manager.fasl"
 #-carbon-compat #P"ccl:library;help-manager.lisp"
 #-carbon-compat #P"ccl:library;help-manager.pfsl"
 ;#P"ccl:library;hide-listener-support.fasl"
 #P"ccl:library;hide-listener-support.lisp"
 #P"ccl:library;hide-listener-support.pfsl"
 ;#P"ccl:library;ICON-DIALOG-ITEM.fasl"
 #P"ccl:library;icon-dialog-item.lisp"
 #P"ccl:library;icon-dialog-item.pfsl"
 ;#P"ccl:library;Inspector Folder:68K:new-backtrace.lisp"
 #1P"ccl:library;Inspector Folder;Inspector Help"
 #P"ccl:library;Inspector Folder;inspector-class.lisp"
 #P"ccl:library;Inspector Folder;inspector-objects.lisp"
 #P"ccl:library;Inspector Folder;inspector-package.lisp"
 #P"ccl:library;Inspector Folder;inspector-window.lisp"
 #P"ccl:library;Inspector Folder;ppc;new-backtrace.lisp"
 ;#P"ccl:library;inspector.fasl"
 ;#P"ccl:library;inspector.lisp"
 ;#P"ccl:library;inspector.pfsl"
 ;#1P"ccl:library;Interfaces:*README*"

 ;#P"ccl:library;interfaces.fasl"
 ;#P"ccl:library;interfaces.lisp"
 ;#P"ccl:library;interfaces.pfsl"
; #P"ccl:library;io-buffer.fasl"
 #P"ccl:library;io-buffer.lisp"
; #P"ccl:library;io-buffer.pfsl"
 #P"ccl:library;Lap-ppc.doc"
 ;#P"ccl:library;Lap.Doc" 
 ;#P"ccl:library;lap.fasl"
 ;#P"ccl:library;lapmacros.fasl"
 ;#P"ccl:library;lisp-package.fasl"
 #P"ccl:library;lisp-package.lisp"
 #P"ccl:library;lisp-package.pfsl"
 ;#P"ccl:library;lispequ.fasl"
 #P"ccl:library;lispequ.lisp"
 #P"ccl:library;lispequ.pfsl"
 ;#P"ccl:library;logical-dir-compatibility.fasl"
 ;#P"ccl:library;logical-dir-compatibility.lisp"
 ;#P"ccl:library;logical-dir-compatibility.pfsl"
 ;#P"ccl:library;loop.fasl"
 #P"ccl:library;loop.lisp"
 #P"ccl:library;loop.pfsl"
 ;#P"ccl:library;mac-file-io.fasl"
 #P"ccl:library;mac-file-io.lisp"
 #P"ccl:library;mac-file-io.pfsl"
 ;#P"ccl:library;macptr-termination.fasl"
 #P"ccl:library;macptr-termination.lisp"
 #P"ccl:library;macptr-termination.pfsl"
 ;#P"ccl:library;MacTCP.fasl"
 ;#P"ccl:library;MacTCP.lisp"
 ;#P"ccl:library;MacTCP.pfsl"
 ;#P"ccl:library;make-help-map.fasl"
 #P"ccl:library;make-help-map.lisp"
 ;#P"ccl:library;make-help-map.pfsl"
 #P"ccl:library;MCL Background.rsrc"
 
 ;#P"ccl:library;mit-loop.fasl"
 #P"ccl:library;mit-loop.lisp"
 #P"ccl:library;mit-loop.pfsl"
 #P"ccl:library;nav-services.lisp"
 #P"ccl:library;nav-services.pfsl"
 ;#P"ccl:library;new-file-dialogs.fasl"
 #-carbon-compat
 #P"ccl:library;new-file-dialogs.lisp"
 #-carbon-compat
 #P"ccl:library;new-file-dialogs.pfsl"
 ;#P"ccl:library;new-scheduler.fasl"
 #P"ccl:library;new-scheduler.lisp"
 #P"ccl:library;new-scheduler.pfsl"
 ;#P"ccl:library;old-file-dialogs.fasl"
 #-carbon-compat
 #P"ccl:library;old-file-dialogs.lisp"
 #-carbon-compat
 #P"ccl:library;old-file-dialogs.pfsl"
 #P"ccl:library;OpenTransport.lisp"
; #P"ccl:library;opentransport.pfsl"
 ;#P"ccl:library;pop-up-menu.fasl"
 #P"ccl:library;pop-up-menu.lisp"
 #P"ccl:library;pop-up-menu.pfsl"
 ;#P"ccl:library;QuickDraw.fasl"
 #P"ccl:library;QuickDraw.lisp"
 #P"ccl:library;quickdraw.pfsl"
 ;#P"ccl:library;records.fasl"
 ;#P"ccl:library;records.lisp"
 ;#P"ccl:library;records.pfsl"
 ;#P"ccl:library;resources.fasl"
 #P"ccl:library;resources.lisp"
 #P"ccl:library;resources.pfsl"
 ;#P"ccl:library;save-application-dialog.fasl"
 #P"ccl:library;save-application-dialog.lisp"
 #P"ccl:library;save-application-dialog.pfsl"
 ;#P"ccl:library;scroll-bar-dialog-items.fasl"
 #P"ccl:library;scroll-bar-dialog-items.lisp"
 #P"ccl:library;scroll-bar-dialog-items.pfsl"
 ;#P"ccl:library;scrollers.fasl"
 #P"ccl:library;scrollers.lisp"
 #P"ccl:library;scrollers.pfsl"
 ;#P"ccl:library;scrolling-fred-view.fasl"
 #P"ccl:library;scrolling-fred-view.lisp"
 #P"ccl:library;scrolling-fred-view.pfsl"
 ;#P"ccl:library;traps.fasl"
 ;#P"ccl:library;traps.lisp"
 ;#P"ccl:library;traps.pfsl"
 #1P"ccl:OpenTransportSupport-Folder;makefile"
 #P"ccl:OpenTransportSupport-Folder;notifier.c"
; #1P"ccl:OpenTransportSupport-Folder;OpenTransportSupport"
 #P"ccl:OpenTransportSupport-Folder;OpenTransportSupport.proj.exp"
;;#1P"ccl:sourceserver;@Read Me@"
 ;#P"ccl:sourceserver;anarchie-interface.lisp"
 #P"ccl:sourceserver;compare-buffers.lisp"
 #P"ccl:sourceserver;compare.lisp"
 ;#P"ccl:sourceserver;fasls;anarchie-interface.fasl"
 ;#P"ccl:sourceserver;fasls;anarchie-interface.pfsl"
 ;#P"ccl:sourceserver;fasls;compare-buffers.fasl"
 ;#P"ccl:sourceserver;fasls;compare-buffers.pfsl"
 ;#P"ccl:sourceserver;fasls;compare.fasl"
 ;#P"ccl:sourceserver;fasls;compare.pfsl"
 ;#P"ccl:sourceserver;fasls;find-folder.fasl"
 ;#P"ccl:sourceserver;fasls;find-folder.pfsl"
 ;#P"ccl:sourceserver;fasls;local-update.fasl"
 ;#P"ccl:sourceserver;fasls;local-update.pfsl"
 ;#P"ccl:sourceserver;fasls;merge.fasl"
 ;#P"ccl:sourceserver;fasls;merge.pfsl"
 ;#P"ccl:sourceserver;fasls;mpw-command.fasl"
 ;#P"ccl:sourceserver;fasls;mpw-command.pfsl"
 ;#P"ccl:sourceserver;fasls;mpw-project.fasl"
 ;#P"ccl:sourceserver;fasls;mpw-project.pfsl"
 ;#P"ccl:sourceserver;fasls;projector-menus.fasl"
 ;#P"ccl:sourceserver;fasls;projector-menus.pfsl"
 ;#P"ccl:sourceserver;fasls;projector-ui.fasl"
; #P"ccl:sourceserver;fasls;projector-ui.pfsl"
 ;;#P"ccl:sourceserver;fasls;projector-utilities.fasl"
 ;#P"ccl:sourceserver;fasls;projector-utilities.pfsl"
 ;#P"ccl:sourceserver;fasls;projector.fasl"
 ;#P"ccl:sourceserver;fasls;projector.pfsl"
 ;#P"ccl:sourceserver;fasls;read-only.fasl"
 ;#P"ccl:sourceserver;fasls;read-only.pfsl"
 ;#P"ccl:sourceserver;fasls;sourceserver-command.fasl"
 ;#P"ccl:sourceserver;fasls;sourceserver-command.pfsl"
 ;#P"ccl:sourceserver;fasls;sublaunch.fasl"
 ;#P"ccl:sourceserver;fasls;sublaunch.pfsl"
 ;#P"ccl:sourceserver;fasls;ui-utilities.fasl"
 ;#P"ccl:sourceserver;fasls;ui-utilities.pfsl"
 #P"ccl:sourceserver;find-folder.lisp"
 ;;#P"ccl:sourceserver;initialize-projects.lisp"
;; #P"ccl:sourceserver;initialize-user.lisp"
;; #P"ccl:sourceserver;load-SourceServer.lisp"
 #P"ccl:sourceserver;SourceServer-subset.lisp"
 ;;#P"ccl:sourceserver;local-update.lisp"
 #P"ccl:sourceserver;merge.lisp"
;; #P"ccl:sourceserver;mpw-command.lisp"
 ;;#P"ccl:sourceserver;mpw-project.lisp"
 ;;#P"ccl:sourceserver;plot-icon.lisp"
;; #P"ccl:sourceserver;projector-menus.lisp"
;; #P"ccl:sourceserver;projector-ui.lisp"
;; #P"ccl:sourceserver;projector-utilities.lisp"
;; #P"ccl:sourceserver;projector.lisp"
 #P"ccl:sourceserver;read-only.lisp"
 #P"ccl:sourceserver;read-only.pfsl"
 ;;#P"ccl:sourceserver;source-server.lisp"
 ;#1P"ccl:sourceserver;SourceServer"
 ;;#P"ccl:sourceserver;sourceserver-command.lisp"
 ;#P"ccl:sourceserver;SourceServer.Log"
;; #P"ccl:sourceserver;sublaunch.lisp"
 ;#P"ccl:sourceserver;Sysequ.lisp"
 #P"ccl:sourceserver;ui-utilities.lisp"

#|
 #P"ccl:Tests:%eval-check-regs.lisp"
; #P"ccl:Tests:%t0.lisp" #P"ccl:Tests:%t00.lisp"
 #1P"ccl:Tests:00 A Testsystem"
 #1P"ccl:Tests:00 All Constants"
 #1P"ccl:Tests:00 All Variables"
 #1P"ccl:Tests:00 Test Testsystem"
 #1P"ccl:Tests:04 Type Specifiers"
 #1P"ccl:Tests:05 Program Structure"
 #1P"ccl:Tests:06 Predicates"
 #1P"ccl:Tests:07 Control Structure"
 #1P"ccl:Tests:08 Macros"
 #1P"ccl:Tests:10 Symbols"
 #1P"ccl:Tests:11 Packages"
 #1P"ccl:Tests:12 Numbers"
 #1P"ccl:Tests:13 Characters"
 #1P"ccl:Tests:14 Sequences"
 #1P"ccl:Tests:15 Lists"
 #1P"ccl:Tests:16 Hash Tables"
 #1P"ccl:Tests:17 Arrays"
 #1P"ccl:Tests:18 Strings"
 #1P"ccl:Tests:22 Input/Output"
 #1P"ccl:Tests:23 File System Interface"
 #1P"ccl:Tests:25 Misc Features"
 #1P"ccl:Tests:28 CLOS"
 #P"ccl:Tests:bfs-tests.lisp"
 #1P"ccl:Tests:Exists" #1P"ccl:Tests:fred"
 #1P"ccl:Tests:Macintosh Basics"
 #1P"ccl:Tests:Menus"
 #1P"ccl:Tests:Notes toward a Fred test"
 #1P"ccl:Tests:Regressions"
 #P"ccl:Tests:run-tests.lisp" #1P"ccl:Tests:stats" 
 #P"ccl:Tests:TS I/O Fns.lisp"
 #P"ccl:Tests:TS Support Fns.Lisp"
 #1P"ccl:Tests:Windows"
|#
 #P"ccl:wood;@Release Notes 0.6"
 #P"ccl:wood;@Release Notes 0.8"
 #P"ccl:wood;@Release Notes 0.9"
 #P"ccl:wood;@release notes 0.91"
 #P"ccl:wood;@Release Notes 0.93"
 #P"ccl:wood;@Release Notes 0.94"
 #P"ccl:wood;@Release Notes 0.96"
 #P"ccl:wood;@Release Notes 0.961"
 #P"ccl:wood;block-io-mcl.lisp"
 #P"ccl:wood;btrees.lisp"
 #P"ccl:wood;disk-cache-accessors.lisp"
 #P"ccl:wood;disk-cache-inspector.lisp"
 #P"ccl:wood;disk-cache.lisp"
 #P"ccl:wood;disk-page-hash.lisp"
 #P"ccl:wood;example.lisp"
 #P"ccl:wood;load-wood.lisp"
 #P"ccl:wood;persistent-clos.lisp"
 #P"ccl:wood;persistent-heap.lisp"
 #P"ccl:wood;q.lisp" #P"ccl:wood;recovery.lisp"
 #P"ccl:wood;split-lfun.lisp"
 #P"ccl:wood;version-control.lisp"
 #P"ccl:wood;wood-gc.lisp" #P"ccl:wood;wood.doc"
 #P"ccl:wood;wood.lisp" #P"ccl:wood;woodequ.lisp"
 #P"ccl:MCL Help"
 ;#P"ccl:MCL Help Map.fasl"
 ;#P"ccl:MCL Help Map.lisp"  ;; is this really needed
 ;#P"ccl:MCL Help Map.pfsl"
 #P"ccl:OpenTransportSupport"
 #P"ccl:release-notes-5.1b2")
*interface-files*
*appearance-files*))

;; change this for where you want to put the files
(setf (logical-pathname-translations "SHIP")
      `(("**;*.*.*" "Macintosh-hd:hd3:MCL-5.1b1:**:*.*.*")))

 
#|

(get-the-files2 "SHIP:" *files-to-ship*)
(dolist (f (directory "ship:**;CVS;*"))
  (delete-file f))

(require :ship-files)
(ship-files ; :VERBOSE T
            :directories
            '("ship:compiler;**;"
              "ship:examples;**;"
              "ship:interface tools;**;"
              "ship:level-0;**;"
              "ship:level-1;**;"
              "ship:lib;**;"
              "ship:library;**;"
              ;"ship:interfaces;**;"
              ;"ship:inspector;**;"
              ;"ship:series;**;"
              "ship:SourceServer;**;"
              "SHIP:WOOD;**;"))

 
 


Remember: 

Then do ship-files on dest files to remove ckid resources etc. ("CCL:lib;ship-files") we forgot
we forgot release notes
add version to *features*
make-methods kernel  ccl:lib;prepare-mcl-environment
package
vers resource
shared bit
2 kernels


|#
