// lisp.h - ndcd include file

typedef unsigned long ulong;


// fulltags

#define ft_mask		3
#define ft_shift	2
#define ftag(x)		(((ulong) (x)) & ft_mask)

#define ft_fixnum	0
#define ft_list		1
#define ft_misc		2
#define ft_imm		3

#define imm_unbound	0x33
#define imm_vsp_protect	0x3B
#define imm_char	0x4B
#define imm_illegal	0x53

// tags

#define t_mask		7
#define t_shift		3
#define tag(x)		(((ulong) (x)) & t_mask)

#define t_efixnum	0
#define t_cons		1
#define t_nodevector	2
#define t_imm		3
#define t_ofixnum	4
#define t_nil		5
#define t_misc		6
#define t_immvector	7

#define obj_ptr(x)	((ulong *)((x) & ~t_mask))
#define obj_header(x)	(*obj_ptr(x))
#define obj_subtag(x)	(obj_header(x) & 0xFF)
#define obj_size(x)	(obj_header(x) >> 8)
#define misc_ref(x, i)	obj_ptr(x)[i]
#define misc_data(x)	&misc_ref(x, 1)

#define ttagp(x, t)	(tag(x) == (t))
#define consp(x)	(ttagp(x, t_cons))
#define nullp(x)	(ttagp(x, t_nil))

#define stagp(x, st)	(ttagp(x, t_misc) && (obj_subtag(x) == (st)))

#define CDR(x)		*((ulong *) ((x) - t_cons))
#define CAR(x)		*((ulong *) (((x) - t_cons) + 4))

// subtags

#define st_bignum	0x07
#define st_ratio	0x0A
#define st_sfloat	0x0F
#define st_dfloat	0x17
#define st_complex	0x1A
#define st_function	0x2A
#define st_symbol	0x3A
#define st_instance	0x72
#define st_u8vector	0xC7
#define st_s8vector	0xCF
#define st_string	0xD7
#define st_gstring	0xDF
#define st_u16vect	0xE7
#define st_s16vect	0xEF
#define st_dfloatvec	0xF7
#define st_bitvect	0xFF

#define symbol_name(x)		misc_ref(x, 1)

#define inst_class_wrapper(x)	misc_ref(x, 1)
#define wrapper_class(x)	misc_ref(x, 3)
#define class_name(x)		misc_ref(x, 2)
#define instance_class_name(x)	class_name(wrapper_class(inst_class_wrapper(x)))
#define method_name(x)		misc_ref(x, 6)
#define method_speczers(x)	misc_ref(x, 3)

#define lfbit_noname	31

#define ppcreg(reg)	(((ulong *) &(reg))[1])

// End of lisp.h
