/*
File "plprint.c" - PLPRINT dcmd

Copyright 1990-1994 Apple Computer, Inc.
Copyright 1995 Digitool, Inc.


Modification History

 11/07/95 slh   ndcd version
 11/03/95 slh   PPC version
  5/19/95 slh   dcmdScroll initially
*/

#include <Types.h>
#include <LowMem.h>
#include <ndcd.h>
#include <put.h>
#include "lisp.h"
#include "printsupp.h"
	
pascal void CommandEntry (dcmdBlock* paramPtr) {
  ulong		value;
  Boolean	ok;

  switch (paramPtr->request) {
	
    case dcmdInit:
      break;

    case dcmdHelp:
			PutCLine("PLPRINT [value]");
			PutCLine("   Displays lisp object represented by 'value'.");
      PutCLine("   If no parameter then use the value of register R23.");
      break;

    case dcmdDoIt:
      if ( dcmdPeekAtNextChar() == '\n' ) {
        OSErr oserr = dcmdReadPowerPCRegister( R23Register, &value );
				if ( oserr ) {
					PutCStr( "Sorry, OSErr " );
					PutUDec( oserr );
					PutCLine( " occurred.");
					return;
				}
			} else {
				(void) dcmdGetNextExpression( (long *) &value, &ok );
				if (!ok) {
					PutCLine("Syntax error");
					return;
				}
			}
      print_object( value );
      break;
    }
}

// End of plprint.c
